=== debian/changelog ===
tremotesf (2.6.0-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:28:22 +1100

tremotesf (2.6.0-1build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 07:19:28 +0000

tremotesf (2.6.0-1) unstable; urgency=medium

  * New upstream release
  * Remove patch merged upstream

 -- Antoine Beaupré <anarcat@debian.org>  Thu, 11 Jan 2024 22:35:18 -0500
