=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: tremotesf
-Maintainer: Antoine Beaupré <anarcat@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Antoine Beaupré <anarcat@debian.org>
 Section: net
 Priority: optional
 Build-Depends: cmake,
