## tremotesf 2.6.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,9 +15,14 @@
     list(APPEND languages OBJCXX)
 endif ()
 
-project(tremotesf VERSION 2.6.0 LANGUAGES ${languages})
+project(tremotesf VERSION 2.6.2 LANGUAGES ${languages})
 
-option(TREMOTESF_QT6 "Build with Qt 6" OFF)
+option(TREMOTESF_QT6 "Build with Qt 6" ON)
+
+set(TREMOTESF_WITH_HTTPLIB "auto" CACHE STRING "Where to find cpp-httplib dependency for unit tests. Possible values are: auto, system, bundled, none")
+if (NOT TREMOTESF_WITH_HTTPLIB MATCHES "^(auto|system|bundled|none)$")
+    message(FATAL_ERROR "Invalid TREMOTESF_WITH_HTTPLIB value ${TREMOTESF_WITH_HTTPLIB}. Possible values are: auto, system, bundled, none")
+endif()
 
 include(CTest)
 include(GNUInstallDirs)
