=== src/CMakeLists.txt ===
--- 
+++ 
@@ -272,7 +272,8 @@
     endif ()
 elseif (WIN32)
     find_library(Dwmapi Dwmapi REQUIRED)
-    target_link_libraries(tremotesf_objects PUBLIC Qt::Svg "${Dwmapi}")
+    find_library(RuntimeObject RuntimeObject REQUIRED)
+    target_link_libraries(tremotesf_objects PUBLIC Qt::Svg "${Dwmapi}" "${RuntimeObject}")
     target_sources(
         tremotesf_objects
         PRIVATE
@@ -299,7 +300,9 @@
 
 # Executable configuration on Windows
 if (WIN32)
+    include("${CMAKE_SOURCE_DIR}/cmake/WindowsMinimumVersion.cmake")
     configure_file(tremotesf.rc.in tremotesf.rc @ONLY)
+    configure_file(tremotesf.manifest.in tremotesf.manifest @ONLY)
     target_sources(
         tremotesf
         PRIVATE
@@ -308,7 +311,7 @@
         "${CMAKE_CURRENT_BINARY_DIR}/tremotesf.rc"
     )
     if (MSVC)
-        target_sources(tremotesf PRIVATE tremotesf.manifest)
+        target_sources(tremotesf PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/tremotesf.manifest")
     else ()
         target_sources(tremotesf PRIVATE tremotesf.manifest.rc)
     endif ()
@@ -351,10 +354,3 @@
     if (WIN32)
         list(APPEND exclude_plugins styles)
     endif ()
-    qt_import_plugins(tremotesf EXCLUDE_BY_TYPE ${exclude_plugins})
-endif ()
-
-if (BUILD_TESTING)
-    find_package(Qt${TREMOTESF_QT_VERSION_MAJOR} ${TREMOTESF_MINIMUM_QT_VERSION} REQUIRED COMPONENTS Test)
-
-    add_executable(itemlistupdater_test itemlistupdater_test.cpp)
