=== debian/control ===
--- 
+++ 
@@ -1,14 +1,9 @@
 Source: tremotesf
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Antoine Beaupré <anarcat@debian.org>
+Maintainer: Antoine Beaupré <anarcat@debian.org>
 Section: net
 Priority: optional
 Build-Depends: cmake,
                debhelper-compat (= 13),
-               dh-cmake,
-               dh-cmake-compat (= 1),
-               dh-sequence-cmake,
-               dh-sequence-ctest,
                gettext,
                libcpp-httplib-dev,
                libcxxopts-dev,
